10 OPEN "COM1:9600,N,8,1, CS0, DS0, CD0" AS #1:'open serial port
100 PRINT #1,"QW";41                           :'Query waveform (m7.4)
110 GOSUB 1000                                      :'Sync on acknowledge
120 INPUT #1,NM$                                    :'Trace_name
130 INPUT #1,YUNIT$                                 :'Y_unit
140 INPUT #1,XUNIT$                                 :'X_unit
150 INPUT #1,YZERO                                  :'Y_zero
160 INPUT #1,XZERO                                  :'X_zero
170 INPUT #1,YRESOL                                 :'Y_resolution
180 INPUT #1,XRESOL                                 :'X_resolution
190 INPUT #1,YRANGE                                 :'Y_range
200 INPUT #1,DT$                                    :'Date
210 INPUT #1,TM$                                    :'Time
220 INPUT #1,DTC                                    :'Delta T correction
230 INPUT #1,MINMAX                                 :'Min Max trace
240 INPUT #1,RES1$                                  :'Reserved field
250 INPUT #1,RES2$                                  :'Reserved field
260 INPUT #1,RES3$                                  :'Reserved field
270 INPUT #1,RES4$                                  :'Reserved field
280 INPUT #1,COUNT%                                 :'Sample_count
285 PRINT "COUNT =";COUNT%
290 DIM WAVE%(2*COUNT%)                               :'Declare waveform array
300 SUM%=0
305 PRINT "reading trace samples ..."
310 FOR I=1 TO 2*COUNT%                             :'2 bytes per sample
320   WAVE%(I)=ASC(INPUT$(1,#1))                     :'Read each sample byte
330   SUM%=(SUM%+WAVE%(I))MOD(256)                      :'Calculate checksum
340 NEXT I
350 CHECKSUM%=ASC(INPUT$(1,#1))                      :'Read checksum
360 IF SUM% = CHECKSUM% THEN GOTO 400                :'Test checksum
380 PRINT "*** Checksum error ***"                  :'Display error message
400 FOR I=1 TO 2*COUNT%
405 IF WAVE%(I) < 128 THEN : A%=WAVE%(I)*256+WAVE%(I+1) : PRINT A%; : GOTO 420
410 B%=WAVE%(I)-128
411 A%=B%*256+WAVE%(I+1)
412 B%=A%-32768!
413 PRINT B%;
420 I=I+1
430 NEXT I
440 PRINT "SUM= ";SUM%;" : CHECKSUM= ";CHECKSUM%
999 END
1000 '-synchronize on acknowledge & handle error:
1010 INPUT#1,ACK
1020 IF (ACK=0) THEN GOTO 1110
1030 IF (ACK<0) OR (ACK>4) THEN GOTO 1100
1040 PRINT "error: ";ACK;
1050 ON ACK GOTO 1060,1070,1080,1090
1060 PRINT "syntax error"               :END
1070 PRINT "execution error"            :END
1080 PRINT "synchronisation error"      :END
1090 PRINT "communication error"        :END
1100 PRINT "unknown acknowledge"        :END
1110 RETURN
