REM $INCLUDE: 'qbdecl.bas'
REM '********************** PROGRAM NAME: TESTIEEE.BAS **********************'
DIM response AS STRING * 5000                        'Size of response string
board = 0                                            'Board number

COLOR 7, 1                      ' Set screen color (white, blue).
CLS
' Set program name in header
COLOR 15, 1                     ' Set screen color.
PRINT TAB(33); "IEEE-488.2 Interactive"
COLOR 7, 1                      ' Set screen color.
LOCATE 2, 1
PRINT STRING$(80, "");
VIEW PRINT 3 TO 25              ' Print between lines 3 & 25.

CALL SendIFC(board)                                'Clear GPIB interface
CALL IBTMO(board, 13)                              'Timeout 10 seconds
CLS
DO
  INPUT "GPIB address (e.g. 8): "; address                  'Enter instr. address
  IF address < 0 OR address > 30 THEN
    invalid = 1: PRINT "GPIB address must be in the range 0 to 30"
  ELSE
    invalid = 0
  END IF
LOOP WHILE invalid = 1
PRINT

DO                              ' Main communications loop.

   LINE INPUT "Command: "; command.string$           'Enter command string
   CALL Send(board, address, command.string$, NLend) 'Send the command
   IF INSTR(command.string$, "?") <> 0 THEN          'Test if query was send
      response$ = CHR$(10)                           'Clear response string
      CALL Receive(board, address, response$, NLend) 'Read response string
      PRINT "Response = ";
      PRINT LEFT$(response$, INSTR(response$, CHR$(10))) 'Print real response
   END IF
'   DO
'      CALL Send(board, address, "SYSTem:ERRor?", NLend) 'Send error query
'      CALL Receive(board, address, response$, NLend)    'Read response
'      IF INSTR(response$, "No error") = 0 THEN          'Test if error
'	   PRINT "Error    = ";
'	   PRINT LEFT$(response$, INSTR(response$, CHR$(10))) 'Print error
'	END IF
'   LOOP UNTIL INSTR(response$, "No error") <> 0 OR INKEY$ = CHR$(27)
    'Read Error queue until "No error"
LOOP UNTIL command.string$ = ""                      'Test for empty string

VIEW PRINT 1 TO 25              ' Print between lines 1 & 25.
COLOR 7, 0                      ' Set screen color (white, black).
CLS 0
DIM addresslist%(2)
addresslist%(1) = address
addresslist%(2) = NOADDR
CALL EnableLocal(board, addresslist%())              'Enable local operation
CALL SendIFC(board)                                  'Clear GPIB interface

END                                                  'End of program
