REM $INCLUDE: 'QBDECL.BAS'
'*****              *****
'***** EXAPPA11.BAS *****
'***** EXample program APPendix A.1.1 in the SCPI Programming Manual.
'*****              *****
DECLARE SUB errorcheck ()
DIM res AS STRING * 100           'Dimension response string
DIM cmd AS STRING                 'Declare command string
EndEOI% = 1                       'Termination Send on LineFeed & EOI
StopEOI% = 256                    'Termination Receive on EOI
' **************************************************
' ******** Program start ***************************
' **************************************************
CLS                               'Clears Output Screen
CALL SendIFC(0)                   'Clears the GPIB interface
CALL IBTMO(0, 13)                 'Timeout at 10 seconds
'
'*** Reset the instrument and clear the status data.
cmd$ = "*rst;*cls"
CALL Send(0, 8, cmd$, EndEOI%)
CALL errorcheck
'
'*** Configure for measuring the frequency of the CAL signal.
cmd$ = "CONFigure:VOLTage:FREQuency (0.6),2000"
CALL Send(0, 8, cmd$, EndEOI%)
PRINT "Frequency  Amplitude   Period    Pos.width  Neg.width"
PRINT "  Hertz      Volts     seconds    seconds    seconds"
PRINT
'
'*** Read the signal characteristics 10 times.
FOR i = 1 TO 10
  cmd$ = "READ:FREQuency?"
  CALL Send(0, 8, cmd$, EndEOI%)
  CALL Receive(0, 8, res$, StopEOI%)     'Enters frequency
  PRINT LEFT$(res$, INSTR(res$, CHR$(10)) - 1); "   ";
  '
  cmd$ = "FETCh:AMPLitude?"
  CALL Send(0, 8, cmd$, EndEOI%)
  CALL Receive(0, 8, res$, StopEOI%)     'Enters amplitude
  PRINT LEFT$(res$, INSTR(res$, CHR$(10)) - 1); "   ";
  '
  cmd$ = "FETCh:PERiod?"
  CALL Send(0, 8, cmd$, EndEOI%)
  CALL Receive(0, 8, res$, StopEOI%)     'Enters period
  PRINT LEFT$(res$, INSTR(res$, CHR$(10)) - 1); "   ";
  '
  cmd$ = "FETCh:PWIDth?"
  CALL Send(0, 8, cmd$, EndEOI%)
  CALL Receive(0, 8, res$, StopEOI%)     'Enters positive pulse width
  PRINT LEFT$(res$, INSTR(res$, CHR$(10)) - 1); "   ";
  '
  cmd$ = "FETCh:NWIDth?"
  CALL Send(0, 8, cmd$, EndEOI%)
  CALL Receive(0, 8, res$, StopEOI%)     'Enters negative pulse width
  PRINT LEFT$(res$, INSTR(res$, CHR$(10)) - 1)
NEXT i
PRINT
CALL errorcheck
' **************************************************
' ******** Program end *****************************
' **************************************************
END

' **************************************************
' Subroutine reading one error from the error queue.
' **************************************************
SUB errorcheck
  er$ = SPACE$(1)
  WHILE LEFT$(er$, 1) <> "0"
  cmd$ = ":SYSTem:ERRor?"
  CALL Send(0, 8, cmd$, 1)                             'Sends error query
  er$ = SPACE$(60)
  CALL Receive(0, 8, er$, 256)                        'Reads error string
  PRINT "error = "; er$                            'Displays error string
  WEND
END SUB

