REM $INCLUDE: 'QBDECL.BAS'
'*****              *****
'***** EXAPPA13.BAS *****
'***** EXample program APPendix A.1.3 in the SCPI Programming Manual.
'*****              *****
DECLARE SUB errorcheck ()
DIM response AS STRING * 20
CLS
CALL SendIFC(0)
CALL IbTMO(0, 13)                              'Time out of 10 seconds
CALL Send(0, 8, "*RST;*CLS", 1)                'Resets and clears
CALL Send(0, 8, "CONFigure:AC", 1)             'Configures for AC-RMS
CALL Send(0, 8, "INITiate", 1)                 'Single initiation
CALL Send(0, 8, "DISPlay:MENU MEASure", 1)     'Displays MEASURE menu
CALL errorcheck
'
'***** Select and read MEAS1 data.
'
PRINT ">>> Press the LOCAL key, set MEAS1 function on, and select MEAS1-volt-dc."
PRINT ">>> Press any key on the controller keyboard when finished."
WHILE INKEY$ = "": WEND
CALL Send(0, 8, "DISPlay:WINDow:TEXT1:DATA?", 1)   'Queries for volt-dc
CALL Receive(0, 8, response$, 256)                 'Reads volt-dc value
PRINT "MEAS1 volt-dc    = "; LEFT$(response$, IBCNT% - 1)

PRINT
PRINT ">>> Press the LOCAL key and select MEAS1-volt-rms."
PRINT ">>> Press any key on the controller keyboard when finished."
WHILE INKEY$ = "": WEND
CALL Send(0, 8, "DISPlay:WINDow:TEXT1:DATA?", 1)   'Queries for volt-rms
CALL Receive(0, 8, response$, 256)                 'Reads volt-rms value
PRINT "MEAS1 volt-rms   = "; LEFT$(response$, IBCNT% - 1)
'
'***** Select and read MEAS2 data.
'
CALL Send(0, 8, "SYSTem:KEY 6", 1)                 'Selects MEASURE menu
PRINT
PRINT ">>> Press the LOCAL key, set MEAS2 function on and select MEAS2-time-freq."
PRINT ">>> Press any key on the controller keyboard when finished."
WHILE INKEY$ = "": WEND
CALL Send(0, 8, "DISPlay:WINDow:TEXT2:DATA?", 1)   'Queries for time-freq
CALL Receive(0, 8, response$, 256)                 'Reads time-freq value
PRINT "MEAS2 time-freq  = "; LEFT$(response$, IBCNT% - 1)

PRINT
PRINT ">>> Press the LOCAL key and select MEAS2-time-period."
PRINT ">>> Press any key on the controller keyboard when finished."
WHILE INKEY$ = "": WEND
CALL Send(0, 8, "DISPlay:WINDow:TEXT2:DATA?", 1)   'Queries for time-period
CALL Receive(0, 8, response$, 256)                 'Reads time-period value
PRINT "MEAS2 time-period= "; LEFT$(response$, IBCNT% - 1)

PRINT
CALL errorcheck
END

'
' **************************************************
' Subroutine reading one error from the error queue.
' **************************************************
SUB errorcheck
  er$ = SPACE$(1)
  WHILE LEFT$(er$, 1) <> "0"
  CMD$ = ":SYSTem:ERRor?"
  CALL Send(0, 8, CMD$, 1)            'Sends error query
  er$ = SPACE$(60)
  CALL Receive(0, 8, er$, 256)        'Reads error string
  IF IBSTA% = TIMO THEN CALL DevClear(0, 8)  'Clears device if time out
  PRINT "error = "; er$               'Displays error string
  WEND
END SUB

