REM $INCLUDE: 'QBDECL.BAS'
'*****              *****
'***** EXAPPA2.BAS *****
'***** EXample program APPendix A.2 in the SCPI Programming Manual.
'*****              *****
DECLARE SUB errorcheck ()
DIM trace(8200)                                    'Array of trace bytes
DIM sample(4096)                                   'Array of trace samples
DIM response AS STRING * 16500
DIM peaktop AS STRING * 10
DIM offset AS STRING * 10
CLS
CALL SendIFC(0)
CALL IbTMO(0, 13)                          'Time out of 10 seconds
CALL Send(0, 8, "*CLS", 1)                 'Clears the status data

'*****
'***** Read channel 1 trace of 512 ... 4096 samples of 1 byte or 2 bytes.
'*****
CALL Send(0, 8, "TRACe? CH1", 1)           'Queries for channel 1 trace
CALL Receive(0, 8, response$, 256)         'Reads channel 1 trace
PRINT "Number of trace bytes ="; IBCNT%    'IBCNT% = length of trace buffer
nr.of.digits = VAL(MID$(response$, 2, 1))                                                         '4 digits
nr.of.bytes = VAL(MID$(response$, 3, nr.of.digits)) - 2
sample.length = ASC(MID$(response$, 3 + nr.of.digits, 1)) / 8                                         'sample = 1 (8/8) or 2 (16/8)
nr.of.samples = nr.of.bytes / sample.length
PRINT "Number of trace samples  ="; nr.of.samples

CALL Send(0, 8, "SENSe:VOLTage:RANGe:PTPeak?", 1)  'Queries peak-to-peak
CALL Receive(0, 8, peaktop$, 256)                  'Reads peak-to-peak
ptpeak = VAL(LEFT$(peaktop$, IBCNT%))
PRINT "atenuation = "; ptpeak / 8; "V/div"
CALL Send(0, 8, "SENSe:VOLTage:RANGe:OFFset?", 1)  'Queries offset range
CALL Receive(0, 8, offset$, 256)                   'Reads offset range
offs = VAL(LEFT$(offset$, IBCNT%))
PRINT "offset     = "; offs; "V"
'***** Notice that trace sample values are inclusive vertical offset.

IF sample.length = 1 THEN
   FOR i = 1 TO nr.of.samples                   '1-byte samples
      trace(i) = ASC(MID$(response$, i + 3 + nr.of.digits, 1))
      IF trace(i) > 127 THEN
	 trace(i) = trace(i) - 256
      END IF
      sample(i) = trace(i) / 200 * ptpeak       'Converts to voltage
      PRINT sample(i),
      IF i MOD 90 = 0 THEN
	 PRINT ">>> Press any key to print next 90 values."
	 WHILE INKEY$ = "": WEND
      END IF
   NEXT i
ELSE
   FOR i = 1 TO nr.of.samples                   '2-byte samples
      J = 2 * i + 2 + nr.of.digits              'Pointer to next sample
      byte1 = ASC(MID$(response$, J, 1))        'M.S.B.
      byte2 = ASC(MID$(response$, J + 1, 1))    'L.S.B.
      IF byte1 < 128 THEN
	 trace(i) = byte1 * 256 + byte2
      ELSE trace(i) = (byte1 - 256) * 256 + byte2
      END IF
      sample(i) = trace(i) / 51200 * ptpeak     'Converts to voltage
      PRINT sample(i),
      IF i MOD 90 = 0 THEN
	 PRINT ">>> Press any key to print next 90 values."
	 WHILE INKEY$ = "": WEND
      END IF
   NEXT i
END IF
PRINT
CALL errorcheck
END

'
' **************************************************
' Subroutine reading one error from the error queue.
' **************************************************
SUB errorcheck
  er$ = SPACE$(1)
  WHILE LEFT$(er$, 1) <> "0"
  CMD$ = ":SYSTem:ERRor?"
  CALL Send(0, 8, CMD$, 1)            'Sends error query
  er$ = SPACE$(60)
  CALL Receive(0, 8, er$, 256)        'Reads error string
  PRINT "error = "; er$               'Displays error string
  WEND
END SUB

