REM $INCLUDE: 'QBDECL.BAS'
'*****              *****
'***** EXAPPA31.BAS *****
'***** EXample program APPendix A.3.1 in the SCPI Programming Manual.
'*****              *****
DECLARE SUB Errorcheck ()
DIM SHARED setupin AS STRING * 350
CLS
CALL SendIFC(0)
CALL IbTMO(0, 13)                        'Time out of 10 seconds
CALL Send(0, 8, "*CLS", 1)               'Clears old status data

SRQ.detected = 0
ON PEN GOSUB ServReq                     'Defines SRQ-routine

'*** Enable SRQ generation after ESR bit 1 "Operation Completed".
CALL Send(0, 8, "*ESE 1", 1)             'ESR-OPC bit = enabled

'*** Operation completed is reported in bit 5 (ESB) of STB after sending *OPC.
CALL Send(0, 8, "*SRE 32", 1)            'STB-ESB bit = enabled

'*** This results in the generation of SRQ after "Operation Completed".
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'*** However, in most cases the mouse software may not be loaded or
'*** active in the computer. So, remove the "mouse load statement"
'*** from the CONFIG.SYS or AUTOEXEC.BAT file.
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

'*** Programs the actual setup by saving/recalling instrument
'*** settings (*SAV/*RCL) to/from internal memory.
'
INPUT "Press y + Enter to SAVE the current instrument setup to memory."; reply$
IF (reply$ = "Y") OR (reply$ = "y") THEN GOSUB Save.Setup
PRINT
'
INPUT "Press y + Enter to READ an instrument setup from memory."; reply$
IF (reply$ = "Y") OR (reply$ = "y") THEN GOSUB Enter.Setup
PRINT

CALL Send(0, 8, "INITiate:CONTinuous OFF", 1) 'Sets Auto trig off
CALL Send(0, 8, "ABORt", 1)                   'Aborts current meas.
PEN ON                                        'Enables SRQ-routine

Repeat.test1:
  CALL Send(0, 8, "INITiate;*OPC", 1)         'Single shot meas.
  timeout = 10                                'Time out of 10 seconds.
  WHILE SRQ.detected = 0
    'Do something else ?
    PRINT ".";
    SLEEP (1)                                 'Delays 1 second
    IF timeout = 0 THEN
       SRQ.detected = 1
       PRINT "Time out on SRQ !": PRINT
    END IF
    timeout = timeout - 1
  WEND
  SRQ.detected = 0
  CALL Send(0, 8, "DISPlay:WINDow:TEXT20:DATA?", 1) 'Requests for dT
  cursdata$ = "               "
  CALL Receive(0, 8, cursdata$, 256)        'Enters dT cursor readout
  PRINT "Cursor readout: "; cursdata$
  CALL Errorcheck
  PRINT "Press any key for next cursor-readout or Ctrl/Break to stop."
  WHILE INKEY$ = "": WEND
GOTO Repeat.test1

END
'
'*** Service Request routine to generate SRQ after "Operation Completed".
'
ServReq:
  PRINT "Service Request generated"
  CALL ReadStatusByte(0, 8, sbyte%) 'Serial polls status byte to reset SRQ
  CALL Send(0, 8, "*ESR?", 1)       'Queries ESR to clear OPC bit
  esr$ = "   "
  CALL Receive(0, 8, esr$, 256)     'Enters ESR status byte
  SRQ.detected = 1
RETURN
'
'*** Routine to recall an instrument setup from memory.
'
Enter.Setup:
  INPUT "Enter an internal memory number from 0 ... 10"; enter.nr$
  IF LEN(enter.nr$) > 2 THEN GOTO Enter.Setup
  IF LEN(enter.nr$) = 2 THEN
    IF VAL(enter.nr$) <> 10 THEN GOTO Enter.Setup
  END IF
  enternr = ASC(enter.nr$)
  IF enternr < 48 OR enternr > 57 THEN GOTO Enter.Setup
  CALL Send(0, 8, "*RCL ", 0)             'Sends header + EOI off
  CALL Send(0, 8, enter.nr$, 1)           'Send mem. nr. + EOI on
  CALL Errorcheck
RETURN
'
'*** Routine to save the current instrument setup to memory.
'
Save.Setup:
  INPUT "Enter an internal memory number from 1 ... 10"; save.nr$
  IF LEN(save.nr$) > 2 THEN GOTO Save.Setup
  IF LEN(save.nr$) = 2 THEN
    IF VAL(save.nr$) <> 10 THEN GOTO Save.Setup
  END IF
  savenr = ASC(save.nr$)
  IF savenr < 49 OR savenr > 57 THEN GOTO Save.Setup
  CALL Send(0, 8, "*SAV ", 0)             'Sends header + EOI off
  CALL Send(0, 8, save.nr$, 1)            'Send mem. nr. + EOI on
  CALL Errorcheck
RETURN

'
' **************************************************
' Subroutine reading one error from the error queue.
' **************************************************
SUB Errorcheck
  er$ = SPACE$(1)
  WHILE LEFT$(er$, 1) <> "0"
  CMD$ = ":SYSTem:ERRor?"
  CALL Send(0, 8, CMD$, 1)            'Sends error query
  er$ = SPACE$(60)
  CALL Receive(0, 8, er$, 256)        'Reads error string
  PRINT "error = "; er$               'Displays error string
  WEND
END SUB

