REM $INCLUDE: 'QBDECL.BAS'
'*****              *****
'***** EXAPPA4.BAS *****
'***** EXample program APPendix A.4 in the SCPI Programming Manual.
'*****              *****
DECLARE SUB errorcheck ()
DIM addr%(2)                              'Dimension address array
DIM response AS STRING * 19000            'Dimension response string 1
NoEOI% = 0                                'No termination on LineFeed & EOI
EndEOI% = 1                               'Termination on LineFeed & EOI
StopEOI% = 256                            'Termination Receive on EOI
' **************************************************
' ******** Program start ***************************
' **************************************************
CLS
CALL SendIFC(0)                           'Clears the GPIB interface
CALL IBTMO(0, 15)                         'Timeout at 100 seconds

PRINT "Turn 'off' the power of the connected plotter to prevent the"
PRINT "harcopy to be plotted as a result of the HCOPy:DATA? query,"
PRINT "which simulates the pressing of the HARD COPY key."
PRINT ">>> Press any key when finished."
PRINT
WHILE INKEY$ = "": WEND
PRINT "Busy reading HPGL plot data from CombiScope instrument."

CALL Send(0, 8, "INSTrument DIGital", EndEOI%) 'Selects digital mode
CALL Send(0, 8, "HCOPy:DEVice HPGL", EndEOI%)  'Selects HPGL data format
CALL Send(0, 8, "HCOPy:DATA?", EndEOI%)        'Queries for hardcopy data
CALL Receive(0, 8, response$, StopEOI%)        'Reads hardcopy data
length = IBCNT%
PRINT "Number of hardcopy bytes ="; length
PRINT "Turn 'on' the power of the connected plotter."
PRINT ">>> Press any key when finished."
PRINT
WHILE INKEY$ = "": WEND

PRINT "Busy sending HPGL plot data to plotter at IEEE address 22."
addr%(0) = 22                             'HPGL-Plotter address = 22
addr%(1) = -1                             'List-termination character
CALL SendSetup(0, addr%())                'HPGL Plotter becomes listener
'*** The first 2 characters are #0 (preamble for indefinite length).
'*** They must not be sent to the plotter (assumed IEEE address 22).
FOR i = 3 TO length - 1
  CALL SendDataBytes(0, MID$(response$, i, 1), 0)
  IF (i MOD 50) = 0 THEN PRINT ".";
NEXT i
CALL SendDataBytes(0, "", EndEOI%)        'Empty byte + EOI detection

PRINT
CALL errorcheck
' **************************************************
' ******** Program end *****************************
' **************************************************
END

' **************************************************
' Subroutine reading one error from the error queue.
' **************************************************
SUB errorcheck
  er$ = SPACE$(1)
  WHILE LEFT$(er$, 1) <> "0"
  CMD$ = ":SYSTem:ERRor?"
  CALL Send(0, 8, CMD$, 1)            'Sends error query
  er$ = SPACE$(60)
  CALL Receive(0, 8, er$, 256)        'Reads error string
  PRINT "error = "; er$               'Displays error string
  WEND
END SUB

