REM $INCLUDE: 'QBDECL.BAS'
'*****
'***** EXAPPA51.BAS
'***** EXample program APPendix A.5.1 in the SCPI Programming Manual.
'*****
'***** This program saves the current Pass/Fail Test setup to file.
'*****
DECLARE SUB Errorcheck ()
DIM SHARED setupin AS STRING * 400
'DIM SHARED setupin AS STRING * 25
DIM SHARED envreg AS STRING * 5
DIM SHARED envelope AS STRING * 5000
CLS
CALL SendIFC(0)
CALL IbTMO(0, 13)                        'Time out of 10 seconds
CALL Send(0, 8, "*CLS", 1)               'Clears old status data
'***
'*** Specify a file name + read from instrument + write to file.
'***
INPUT "Enter 'path/directory/file_name' of the setup file."; replyout$
OPEN replyout$ FOR OUTPUT AS #1 LEN = 6000
'OPEN "O", #1, replyout$        'Opens file with name in REPLYOUT$
   GOSUB Save.Setup            'Writes system settings to file
   GOSUB Save.Envreg           'Writes envelope register to file
CLOSE                          'Closes file
END
'
'*** Routine to load the Pass/Fail Test settings + save it to file.
'
Save.Setup:
   CALL Send(0, 8, "SYSTem:SET?", 1)       'Requests for settings
'   CALL Send(0, 8, "SYSTem:SET? 51", 1)    'Requests for PFT settings
   CALL Receive(0, 8, setupin$, 256)       'Reads the settings
   lengths = IBCNT%
   PRINT "Number of system settings bytes = "; IBCNT%
   PRINT #1, lengths
   PRINT #1, setupin$
   CALL Errorcheck
RETURN
'
'*** Routine to load the pass/fail test envelope + save it to file.
'
Save.Envreg:
   '***
   '*** Specify the pass/fail test envelope register.
   '***
   PRINT "Enter 'memory_register' of reference envelope, e.g.: 2_1"
   PRINT "(Example: 2_1 selects memory 2 and register 1)"
   INPUT ">>>>>>> "; envreg$
   CALL Send(0, 8, "TRACe? M", 0)
   CALL Send(0, 8, envreg$, 1)
   CALL Receive(0, 8, envelope$, 256)
   lengthe = IBCNT%
   PRINT "Number of envelope trace bytes ="; lengthe
   PRINT #1, envreg$
   PRINT #1, lengthe
   PRINT #1, envelope$
   CALL Errorcheck
RETURN

DEFINT A-Z
' **************************************************
' Subroutine reading one error from the error queue.
' **************************************************
SUB Errorcheck
  er$ = SPACE$(1)
  WHILE LEFT$(er$, 1) <> "0"
  CMD$ = ":SYSTem:ERRor?"
  CALL Send(0, 8, CMD$, 1)            'Sends error query
  er$ = SPACE$(60)
  CALL Receive(0, 8, er$, 256)        'Reads error string
  PRINT "error = "; er$               'Displays error string
  WEND
END SUB

