REM $INCLUDE: 'QBDECL.BAS'
'*****
'***** EXAPPA52.BAS
'***** EXample program APPendix A.5.2 in the SCPI Programming Manual.
'*****
'***** This program restores a Pass/Fail Test setup from file.
'*****
DECLARE SUB Errorcheck ()
DIM SHARED envreg AS STRING * 5
CLS
CALL SendIFC(0)
CALL IbTMO(0, 13)                        'Time out of 10 seconds
CALL Send(0, 8, "*CLS", 1)               'Clears old status data
CLOSE
'***
'*** Specify a file name + read from file + write to instrument.
'***
INPUT "Enter 'path/directory/file_name' of the setup file."; replyin$
OPEN replyin$ FOR INPUT AS #1
			       'Opens file with name in REPLYIN$
   GOSUB Enter.Setup           'Enters system settings from file
   GOSUB Enter.Envreg          'Enters envelope register from file
CLOSE                          'Closes file
END
'
'*** Routine to enter an instrument setup from file + download it.
'
Enter.Setup:
   LINE INPUT #1, len$
   lengths = VAL(len$)
   PRINT "Instrument setup length ="; lengths; "bytes"
   setupout$ = ""                      'Empty string
   i = 1                               'Loop pointer
Repeat.Settings:
   WHILE NOT EOF(1) AND i < lengths
      setupout$ = setupout$ + INPUT$(1, #1)  'Adds to setup string
      i = i + 1                              'Increments loop pointer
   WEND
   '***
   '*** It is very well possible that the EOF character (dec. 26) is
   '*** among the settings data a number of times. The input of EOF
   '*** causes the INPUT$ statement to stop, so that not all data is
   '*** entered. To overcome this, the next IF ... END IF statements
   '*** are added to continue the input of all data bytes.
   '***
   IF i < lengths THEN                     'EOF (dec. 26) is detected
      setupout$ = setupout$ + CHR$(26)     'EOF char. = dec. 26 = Ctrl/Z
      i = i + 1                            'Increments loop pointer
      file.point = SEEK(1)                 'Saves file pointer
      CLOSE                                'Closes file
      OPEN replyin$ FOR INPUT AS #1        'Reopens file
      SEEK #1, file.point + 1              'Restores file pointer + 1
      GOTO Repeat.Settings
   END IF
   '***
   '*** Write the pass/fail system settings.
   '***
   CALL Send(0, 8, "SYSTem:SET ", 0)               'Sends SCPI header
   CALL Send(0, 8, LEFT$(setupout$, lengths), 0)   'Sends settings buffer
   CALL Send(0, 8, "", 1)                          'Sends EOL termination
   CALL Errorcheck
RETURN
'
'*** Routine to enter a reference envelope from file + download it.
'
Enter.Envreg:
   LINE INPUT #1, len$                 'Enters empty line from file
   LINE INPUT #1, envreg$              'Enters envelope register
   LINE INPUT #1, len$                 'Enters envelope length
   lengthe = VAL(len$)
   PRINT "Number of envelope trace bytes ="; lengthe
   envelope$ = ""                      'Empty string
   i = 1                               'Loop pointer
Repeat.Envelope:
   WHILE NOT EOF(1) AND i < lengthe
      envelope$ = envelope$ + INPUT$(1, #1)  'Adds to envelope string
      i = i + 1                              'Increments loop pointer
   WEND
   '***
   '*** It is very well possible that the EOF character (dec. 26) is
   '*** among the envelope data a number of times. The input of EOF
   '*** causes the INPUT$ statement to stop, so that not all data is
   '*** entered. To overcome this, the next IF ... END IF statements
   '*** are added to continue the input of all data bytes.
   '***
   IF i < lengthe THEN                     'EOF (dec. 26) is detected
      envelope$ = envelope$ + CHR$(26)     'EOF char. = dec. 26 = Ctrl/Z
      i = i + 1                            'Increments loop pointer
      file.point = SEEK(1)                 'Saves file pointer
      CLOSE                                'Closes file
      OPEN replyin$ FOR INPUT AS #1        'Reopens file
      SEEK #1, file.point + 1              'Restores file pointer + 1
      GOTO Repeat.Envelope
   END IF
   '***
   '*** Write the pass/fail test envelope register.
   '***
   CALL Send(0, 8, "TRACe M", 0)                  'Sends header
   CALL Send(0, 8, LEFT$(envreg$, 3) + ",", 0)    'Sends register + comma
   CALL Send(0, 8, LEFT$(envelope$, lengthe), 0)  'Sends envelope data
   CALL Send(0, 8, "", 1)                         'Sends EOL termination
   CALL Errorcheck
RETURN

'
' **************************************************
' Subroutine reading one error from the error queue.
' **************************************************
SUB Errorcheck
  er$ = SPACE$(1)
  WHILE LEFT$(er$, 1) <> "0"
  CMD$ = ":SYSTem:ERRor?"
  CALL Send(0, 8, CMD$, 1)            'Sends error query
  er$ = SPACE$(60)
  CALL Receive(0, 8, er$, 256)        'Reads error string
  PRINT "error = "; er$               'Displays error string
  WEND
END SUB

