'*****
'***** EXAPPB51.BAS (for TestTeam Plus and LabWindows).
'***** EXample program APPendix A.5.1 in the SCPI Programming Manual.
'*****
'
'***** This program saves the current Pass/Fail Test setup to file,
'***** which can be recalled with the EXAPPB51.BAS program.
'*****
REM     $INCLUDE: 'C:\LW\instr\iogpib.inc'
DEFINT A-Z
DIM SHARED envreg AS STRING * 5
DIM SHARED pftfile AS STRING * 40
DIM SHARED systerr AS STRING * 60
DIM SHARED settings AS STRING * 400
DIM SHARED envelope AS STRING * 5000

CLS
CALL SendIFC(0)
CALL IbTMO(0, 13)                       'Sets time out at 10 seconds
CALL Send(0, 8, "*CLS", 4, 2)           'Clears status data
'
'*** Read the actual system settings.
'
CALL Send(0, 8, "SYSTem:SET?", 11, 2)
CALL Receive(0, 8, settings$, 400, 256)
lengths = IBCNT%
PRINT "Number of instrument settings bytes ="; lengths
'
'*** Read the reference envelope from memory_register to be specified.
'
PRINT "Enter 'memory_register' of reference envelope, e.g.: 2_1"
PRINT "(Example: 2_1 selects memory 2 and register 1)"
INPUT ">>>>>>> "; envreg$
CALL Send(0, 8, "TRACe? M", 8, 0)
CALL Send(0, 8, envreg$, 3, 2)
CALL Receive(0, 8, envelope$, 5000, 256)
lengthe = IBCNT%
PRINT "Number of envelope trace bytes ="; lengthe
CALL Send(0, 8, "SYST:ERR?", 9, 2)
CALL Receive(0, 8, systerr$, 60, 256)
PRINT systerr$
n = CompareBytes(systerr$, 0, "0", 0, 1, 0)
IF n <> 0 THEN
  PRINT "Program stopped."
  STOP
END IF
'
'*** Save the current Pass/Fail Test setup to file to be specified.
'
INPUT "Enter 'path/directory/file_name' of the setup file."; pftfile$
file.handle = OpenFile(pftfile$, 2, 0, 0)       'Binary output
IF file.handle < 0 THEN
  PRINT "Error opening file: "; pftfile$
  STOP
END IF
n = FmtFile(file.handle, "%s<%i", lengths)
IF n <> 1 THEN
  PRINT "Error writing settings.length to file: "; pftfile$
  STOP
END IF
n = WriteFile(file.handle, CHR$(10), 1)
n = FmtFile(file.handle, "%s<%s[w343t-]", settings$)
IF n <> 1 THEN
  PRINT "Error writing settings to file: "; pftfile$
  STOP
END IF
n = WriteFile(file.handle, CHR$(10), 1)
n = FmtFile(file.handle, "%s<%s[w4t-]", envreg$)
IF n <> 1 THEN
  PRINT "Error writing envelope mem. reg. to file: "; pftfile$
  STOP
END IF
n = WriteFile(file.handle, CHR$(10), 1)
n = FmtFile(file.handle, "%s<%i", lengthe)
IF n <> 1 THEN
  PRINT "Error writing envelope.length to file: "; pftfile$
  STOP
END IF
n = WriteFile(file.handle, CHR$(10), 1)
n = FmtFile(file.handle, "%s<%s[w1033t-]", envelope$)
IF n <> 1 THEN
  PRINT "Error writing envelope to file: "; pftfile$
  STOP
END IF
n = CloseFile(file.handle)

CALL iolocal(708)
PRINT "Saving ended."

