'*****
'***** EXAPPB52.BAS (for TestTeam Plus and LabWindows).
'***** EXample program APPendix A.5.2 in the SCPI Programming Manual.
'*****
'*****
'***** This program recalls a Pass/fail Test setup from file, which was
'***** previously saved with the EXAPPB51.BAS program.
'*****
REM     $INCLUDE: 'C:\LW\instr\iogpib.inc'
DEFINT A-Z
DIM SHARED envreg AS STRING * 5
DIM SHARED pftfile AS STRING * 40
DIM SHARED systerr AS STRING * 60
DIM SHARED settings AS STRING * 400
DIM SHARED envelope AS STRING * 5000

CLS
CALL SendIFC(0)
CALL IbTMO(0, 13)                       'Sets time out at 10 seconds
CALL Send(0, 8, "*CLS", 4, 2)           'Clears status data
'
'*** Read the Pass/Fail Test setup from file to be specified.
'
INPUT "Enter 'path/directory/file_name' of the setup file."; pftfile$
file.handle = OpenFile(pftfile$, 1, 2, 0)       'Binary input
IF file.handle < 0 THEN
  PRINT "Error opening file: "; pftfile$
  STOP
END IF
n = ScanFile(file.handle, "%s>%i", lengths)
PRINT "lengths ="; lengths
n = ReadFile(file.handle, settings$, lengths)
dummy$ = " "
n = ReadFile(file.handle, dummy$, 1)            'Read CHR$(10)
n = ReadFile(file.handle, envreg$, 3)
PRINT "env. reg. = "; envreg$
n = ReadFile(file.handle, dummy$, 1)            'Read CHR$(10)
n = ReadFile(file.handle, dummy$, 1)            'Read CHR$(10)
n = ScanFile(file.handle, "%s>%i", lengthe)
PRINT "lengthe ="; lengthe
n = ReadFile(file.handle, envelope$, lengthe)
n = CloseFile(file.handle)
'
'*** Send the recalled system settings to instrument.
'
PRINT "Number of instrument settings bytes ="; lengths
CALL Send(0, 8, "SYSTem:SET ", 11, 0)
length& = lengths
CALL Send(0, 8, settings$, length& - 1, 0)
CALL Send(0, 8, CHR$(10), 1, 2)
CALL Send(0, 8, "SYST:ERR?", 9, 2)
CALL Receive(0, 8, systerr$, 60, 256)
PRINT systerr$
n = CompareBytes(systerr$, 0, "0", 0, 1, 0)
IF n <> 0 THEN
  PRINT "Program stopped."
  STOP
END IF
'
'*** Send the recalled reference envelope to instrument.
'
PRINT "Number of envelope trace bytes ="; lengthe
CALL Send(0, 8, "TRACe M", 7, 0)
CALL Send(0, 8, envreg$, 3, 0)
CALL Send(0, 8, ",", 1, 0)
length& = lengthe
CALL Send(0, 8, envelope$, length&, 0)
CALL Send(0, 8, "", 0, 2)
CALL Send(0, 8, "SYST:ERR?", 9, 2)
CALL Receive(0, 8, systerr$, 60, 256)
PRINT systerr$
n = CompareBytes(systerr$, 0, "0", 0, 1, 0)
IF n <> 0 THEN
  PRINT "Program stopped."
  STOP
END IF

CALL iolocal(708)
PRINT "Restoring ended."

