REM ***
REM *** TALKCPL.BAS : Controls an instrument via serial interface.
REM ***
DECLARE SUB Response ()
DEFINT A-Z

DECLARE SUB Acknowledge (Ack$)

'***
'Open communications (variable baudrate, no parity, 8-bit data,
'1 stop bit, 2048-byte input buffer) for COM<n>:
'***
CLS
Read.Com:                       'Reads COM<n> port number
  PRINT
  INPUT "Enter index for the COM port, e.g.: 2 for COM2"; com.nr$
  com.nr% = VAL(com.nr$)
  IF com.nr% < 1 OR com.nr% > 4 GOTO Read.Com
Read.Baudrate:                  'Reads instrument's baudrate
  PRINT
  INPUT "Enter baudrate as set by the instrument, e.g. 1200"; baud.rate$
  baud.rate& = VAL(baud.rate$)
device$ = "COM" + LTRIM$(STR$(com.nr%)) + ":" + LTRIM$(STR$(baud.rate&)) + ",N,8,1,RB2048"
OPEN device$ FOR RANDOM AS #1 LEN = 2048

COLOR 7, 1                      ' Set screen color (white, blue).
CLS
				' Values returned by INKEY$
' Set program name in header
COLOR 15, 1                     ' Set screen color.
PRINT TAB(33); "CPL Interactive"
COLOR 7, 1                      ' Set screen color.
LOCATE 2, 1
PRINT STRING$(80, "");
VIEW PRINT 3 TO 25              ' Print between lines 3 & 25.

new.command = 1
PRINT "Command: ";

DO                                   ' Main communications loop.

   KeyInput$ = INKEY$                ' Check the keyboard.

   IF KeyInput$ = CHR$(13) AND new.command = 1 THEN
      EXIT DO                        ' Exit loop if only Enter pressed.

   ELSEIF KeyInput$ = CHR$(13) THEN  ' Read response if user pressed Enter.
      PRINT #1, KeyInput$;           ' Send typed character to the Scope.
      PRINT "<CR>"
      CALL Acknowledge(Ack$)
      CALL Response
      new.command = 1
      PRINT "Command: ";

   ELSEIF KeyInput$ <> "" THEN  ' Otherwise, if the user has
				' pressed a key
      new.command = 0
      PRINT KeyInput$;          ' Print character on screen
      PRINT #1, KeyInput$;      ' Send the character typed to
				' the Scope.
   END IF
LOOP

CLOSE                           ' End communications.
COLOR 7, 0                      ' Set screen color (white, black).
VIEW PRINT
CLS
END

DEFSNG A-Z
SUB Acknowledge (Ack$)
      PRINT "Acknowledge = ";
	  Ack$ = INPUT$(1, #1)
	  ackterm$ = INPUT$(1, #1)
      IF Ack$ <> "0" THEN
	  COLOR 15, 4           ' Set screen color.
      END IF
      PRINT Ack$;
      COLOR 7, 1                ' Set screen color.
      PRINT
END SUB

DEFINT A-Z
SUB Response
      start! = TIMER
      WHILE ((TIMER < (start! + 1)) AND (LOC(1) = 0))
      WEND
    
      IF LOC(1) > 0 THEN
	   PRINT "Response = ";
	   timeout! = TIMER
	   DO
	       ' LOC(1) gives the number of characters waiting:
	       ScopeInput$ = INPUT$(LOC(1), #1)
	       PRINT ScopeInput$;
	       start! = TIMER
	       WHILE ((TIMER < (start! + 1)) AND (LOC(1) = 0))
	       WEND
	   LOOP WHILE LOC(1) > 0
	   PRINT
      END IF

END SUB

